/*
 * Tunnel.java
 */

package org.grizzly.tunnel;

/**
 * @author Alexey Stashok
 */
public class Tunnel {
    
    private int sourcePort;
    private String targetHost;
    private int targetPort;
    
    public Tunnel(int sourcePort, String targetHost, int targetPort) {
        this.sourcePort = sourcePort;
        this.targetHost = targetHost;
        this.targetPort = targetPort;
    }
    
    public void process() {
        initializeServer().start();
    }

    private TunnelListener initializeServer() {
        return new TunnelListener(sourcePort, 
                new ProxyFilter(targetHost, targetPort));
    }
    
    public static void main(String[] args) {
        if (args.length != 3) {
            System.out.println("Parameters missed! Use Tunnel <source_port> <target_host> <target_port>");
            System.exit(1);
        }
        
        int sourcePort = Integer.parseInt(args[0]);
        String targetHost = args[1];
        int targetPort = Integer.parseInt(args[2]);
        Tunnel tunnel = new Tunnel(sourcePort, targetHost, targetPort);
        tunnel.process();
    }
}
